-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 04500 of the CMF schema. Migration code to be applied on top of the
-- previous version.
--

update SCHEMA_VERSION set VERSION=04500;

--
-- Add new table ROLE_CONFIG_GROUPS that is used to group
-- identically configured roles.
--
create table ROLE_CONFIG_GROUPS (
    ROLE_CONFIG_GROUP_ID int8 not null,
    SERVICE_ID int8 not null,
    ROLE_TYPE varchar(255) not null,
    NAME varchar(255) not null,
    primary key (ROLE_CONFIG_GROUP_ID)
);

-- Service + RoleType + Name must be unique

create unique index IDX_UNIQUE_ROLE_CONFIG_GROUP on ROLE_CONFIG_GROUPS
    (SERVICE_ID, ROLE_TYPE, NAME);

create index FK_ROLE_CONFIG_GROUP_SERVICE on ROLE_CONFIG_GROUPS (SERVICE_ID);

alter table ROLE_CONFIG_GROUPS
    add constraint FK_ROLE_CONFIG_GROUP_SERVICE
    foreign key (SERVICE_ID)
    references SERVICES (SERVICE_ID);

-- Add role config group to ROLES

alter table ROLES
    add column ROLE_CONFIG_GROUP_ID int8;

create index FK_ROLE_ROLE_CONFIG_GROUP on ROLES (ROLE_CONFIG_GROUP_ID);

alter table ROLES
    add constraint FK_ROLE_ROLE_CONFIG_GROUP
    foreign key (ROLE_CONFIG_GROUP_ID)
    references ROLE_CONFIG_GROUPS (ROLE_CONFIG_GROUP_ID);
