-- Copyright (c) 2013 Cloudera, Inc. All rights reserved.
--
-- Version 12 of the CMON schema.
--
-- Change MySQL indexes on CMON_ACTIVITY.
-- Change the partition information table to have an explicit start time and
-- a type.
-- Create explicit time-range partitions if needed (done in java).
ALTER TABLE PARTITION_INFO ADD COLUMN BEGIN_TS BIGINT;
ALTER TABLE PARTITION_INFO ADD COLUMN TYPE INT;

-- '0' is the ordinal of the PERIODIC PartitionType enum value.
UPDATE PARTITION_INFO SET TYPE = 0 WHERE TYPE IS NULL;
ALTER TABLE PARTITION_INFO ALTER COLUMN TYPE SET NOT NULL;

-- Create an index on the start and end time of activities.
CREATE INDEX IDX_ACTIVITY_START_TIME ON CMON_ACTIVITY(BEGIN_TS);
CREATE INDEX IDX_ACTIVITY_END_TIME ON CMON_ACTIVITY(END_TS);

-- For some reason this does not use a sequence. Let's fix it as it will
-- make our life when creating partitions easier.
CREATE SEQUENCE CMON_ATTEMPT_SEQUENCE;
ALTER TABLE CMON_ATTEMPT ALTER COLUMN ID SET DEFAULT NEXTVAL('CMON_ATTEMPT_SEQUENCE');

-- Partition old data if necessary.
com.cloudera.cmon.firehose.db.PartitionOldAmonData
