// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.

define(["cloudera/search/SearchFilters","cloudera/search/FilterModel","knockout","underscore"],function(e,t,n,r){describe("SearchFilters",function(){var i,s,o,u,a,f,l;beforeEach(function(){jasmine.Ajax.useMock(),u={status:200,responseText:JSON.stringify({success:!0})},i=$("<div></div>").appendTo($("body")),s=[],a=jasmine.createSpy("exportResults"),l=jasmine.createSpy("searchFunction"),f={filterContainer:i[0],filtersUrl:"test/filters/url",searchFunction:l,staticFilters:s,exportResults:a},o=new e(f)}),afterEach(function(){i.remove()}),it("defines some attributes",function(){expect(o.filterContainer).toBeDefined(),expect(o.filters).toBeDefined(),expect(o.staticFilters).toBeDefined(),expect(o.appliedFilters).toBeDefined(),expect(o.filtersUrl).toBeDefined()}),it("applies bindings upon instantiation",function(){spyOn(n,"applyBindings"),o=new e(f),spyOn(o,"insertFilter"),spyOn(o,"removeFilter"),expect(n.applyBindings.callCount).toEqual(1);var t=n.applyBindings.argsForCall[0];expect(t[1]).toEqual(i[0]);var r=t[0];expect(r.filters).toEqual(o.filters),expect(r.staticFilters).toEqual(o.staticFilters),expect(r.appliedFilters).toEqual(o.appliedFilters),expect(r.loading).toEqual(o.loading),expect(r.search).toEqual(f.searchFunction),expect(r.addFilter).toBeDefined(),expect(r.removeFilter).toBeDefined(),expect(r.generateTokenizeConfig).toBeDefined(),r.addFilter(),expect(o.insertFilter).wasCalled(),r.removeFilter(),expect(o.removeFilter).wasCalled()}),describe("view model",function(){var t;beforeEach(function(){spyOn(n,"applyBindings"),o=new e(f),expect(n.applyBindings.callCount).toEqual(1);var r=n.applyBindings.argsForCall[0];expect(r[1]).toEqual(i[0]),t=r[0]}),it("addFilter calls insertFilter with number for argument",function(){spyOn(o,"insertFilter"),t.addFilter(2),expect(o.insertFilter).wasCalled();var e=o.insertFilter.argsForCall[0];expect(e[1]).toEqual(3);var n=e[0];expect(n.filter).toBeDefined(),expect(n.compareType).toBeDefined(),expect(n.values).toBeDefined()}),it("addFilter calls insertFilter with observable for argument",function(){spyOn(o,"insertFilter"),t.addFilter(n.observable(5)),expect(o.insertFilter).wasCalled();var e=o.insertFilter.argsForCall[0];expect(e[1]).toEqual(6)})}),describe("generateTokenizeConfig",function(){var t,r,i;beforeEach(function(){spyOn(n,"applyBindings"),o=new e(f),expect(n.applyBindings.callCount).toEqual(1);var s=n.applyBindings.argsForCall[0];t=s[0].generateTokenizeConfig,i={valueUri:"/some/path/to/filter/values"},r={filter:jasmine.createSpy("filter").andReturn(i)}}),it("sets base options correctly",function(){var e=t(r);expect(e.convertServerResponse).toBeDefined(),expect(e.convertValue).toBeDefined(),expect(e.tokenInputOptions).toBeDefined(),expect(e.tokenInputOptions.preventDuplicates).toBeTruthy();var n=e.convertServerResponse(["catpants","doggyhat"]);expect(n.length).toEqual(2),expect(n[0].id).toEqual("catpants"),expect(n[0].name).toEqual("catpants"),expect(n[1].id).toEqual("doggyhat"),expect(n[1].name).toEqual("doggyhat"),n=e.convertValue("horsepoo"),expect(n.id).toEqual("horsepoo"),expect(n.name).toEqual("horsepoo")}),it("sets valueUri as source when present",function(){var e=t(r);expect(e.source).toEqual(i.valueUri)}),it("provides values as source correctly",function(){i.valueUri=null,i.values=["catpants","doggyhat","horsepoo"];var e=t(r);expect(e.source.length).toEqual(3),expect(e.source[0].id).toEqual("catpants"),expect(e.source[0].name).toEqual("catpants"),expect(e.source[1].id).toEqual("doggyhat"),expect(e.source[1].name).toEqual("doggyhat"),expect(e.source[2].id).toEqual("horsepoo"),expect(e.source[2].name).toEqual("horsepoo")}),it("shows all values if no typeahead match",function(){i.valueUri=null,i.values=["catpants","doggyhat","horsepoo"];var e=t(r),n=e.convertServerResponse([]);expect(n.length).toEqual(3),expect(n[0].id).toEqual(i.values[0]),expect(n[1].id).toEqual(i.values[1]),expect(n[2].id).toEqual(i.values[2])}),it("shows values if typeahead match",function(){i.valueUri=null,i.values=["catpants","doggyhat","horsepoo"];var e=t(r),n=e.convertServerResponse(["catpants","doggyhat"]);expect(n.length).toEqual(2),expect(n[0]).toEqual("catpants"),expect(n[1]).toEqual("doggyhat")})}),it("can get a compare type from its name",function(){var e={name:"compareType1"},t={name:"compareType2"},n={compareTypes:[e,t]},r=o.compareTypeFromName(n,"compareType2");expect(r).toEqual(t),r=o.compareTypeFromName(n,"unknown"),expect(r).toBeFalsy()}),it("correctly inserts filters",function(){var e=new t;expect(o.appliedFilters().length).toEqual(0),o.insertFilter(e),expect(o.appliedFilters().length).toEqual(1)}),it("does not insert if any filters are duplicates",function(){var e=new t;e.filter("filter"),e.compareType("compareType"),e.value("value"),expect(o.appliedFilters().length).toEqual(0),o.insertFilter(e),expect(o.appliedFilters().length).toEqual(1);var n=new t;n.filter("filter"),n.compareType("compareType"),n.value("value"),o.insertFilter(n),expect(o.appliedFilters().length).toEqual(1)}),it("inserts filters by index if given",function(){var e=new t;e.filter("filter1");var n=new t;n.filter("filter2");var r=new t;r.filter("filter3"),o.insertFilter(e),o.insertFilter(n),expect(o.appliedFilters().length).toEqual(2),o.insertFilter(r,1),expect(o.appliedFilters()[1]).toEqual(r)}),it("knows how to remove a filter",function(){var e=new t;e.filter("filter1"),e.compareType("compareType1"),e.value("value1");var n=new t;n.filter("filter2"),n.compareType("compareType2"),n.value("value2"),o.insertFilter(e),o.insertFilter(n),expect(o.appliedFilters().length).toEqual(2);var r=0;o.appliedFilters.subscribe(function(){r+=1}),o.removeFilter(e),expect(o.appliedFilters().length).toEqual(1),expect(r).toEqual(1)}),it("loads filters via a getJSON call",function(){spyOn(o,"loadFiltersHandler"),o.loadFilters();var e=mostRecentAjaxRequest();e.response(u),expect(o.loadFiltersHandler).wasCalled()}),it("knows how to handle the filters response from the server",function(){o.filters([1,2]);var e={message:"OK",data:[4,5,6]};o.loadFiltersHandler(e),expect(o.filters().length).toEqual(3);var t=o.filters();expect(t[0]).toEqual(4),expect(t[1]).toEqual(5),expect(t[2]).toEqual(6)}),it("calls a callback when filters are loaded",function(){o.filters([1,2]);var e=jasmine.createSpy("load filters callback");o.loadFilters(e);var t=mostRecentAjaxRequest();t.response(u),expect(e).wasCalled()}),it("can return all the applied filters",function(){var e=function(e){var n=new t;return n.filter({propertyName:"propertyName "+e}),n.compareType({name:"compareType "+e}),n.value("value "+e),n},n=e(1),r=e(2),i=e(3),s=new t;s.filter({propertyName:"propertyName 4"}),s.compareType({name:"compareType 4"}),s.values(["value 4.1","value 4.2"]),i.value(null);var u={values:["value 0"]};o.staticFilters=[u],o.appliedFilters([n,r,i,s]);var a=o.getAppliedFilters();expect(a.length).toEqual(4),expect(a[0].values).toEqual(["value 0"]),expect(a[1].values).toEqual(["value 1"]),expect(a[2].values).toEqual(["value 2"]);var f=a[3].values;expect(f.length).toEqual(2),expect(f[0]).toEqual("value 4.1"),expect(f[1]).toEqual("value 4.2")}),it("can find filters",function(){var e={propertyName:"filter1"},t={propertyName:"filter2"},n={propertyName:"filter3"};o.filters([e,t,n]);var r=o.findFilter("filter2");expect(r).toEqual(t),r=o.findFilter("unknown"),expect(r).toEqual(null)}),it("can register filters",function(){var e={};expect(o.filters().length).toEqual(0),o.registerFilter(e),expect(o.filters().length).toEqual(1),expect(o.filters()[0]).toEqual(e);var t={},n={};o.registerAllFilters([t,n]),expect(o.filters().length).toEqual(3)}),it("won't register a filter that is in the static filters list",function(){var e={};expect(o.filters().length).toEqual(0),o.registerFilter(e),expect(o.filters().length).toEqual(1),expect(o.filters()[0]).toEqual(e);var t={propertyName:"static"};o.staticFilters=[t];var n={propertyName:"static"},i={};o.registerAllFilters([n,i]),expect(o.filters().length).toEqual(2),expect(r.find(o.filters(),function(e){return t.propertyName===e.propertyName})).toBeUndefined()}),it("adds utility methods to registered filters",function(){var e={};o.registerFilter(e),expect(e.has).toBeDefined(),expect(e.hasnt).toBeDefined(),e.catpants=!0,expect(e.has("catpants")).toBeTruthy(),expect(e.has("catpants","doghat")).toBeFalsy(),expect(e.hasnt("catpants")).toBeFalsy(),expect(e.hasnt("catpants","doghat")).toBeTruthy()}),it("can clear out the filters",function(){var e={propertyName:"filter1"},t={propertyName:"filter2"},n={propertyName:"filter3"};o.filters([e,t,n]),expect(o.filters().length).toEqual(3),o.clearFilters(),expect(o.filters().length).toEqual(0)}),it("converts single value to singleton array for values",function(){spyOn(o,"compareTypeFromName").andReturn("compareType"),spyOn(o,"insertFilter").andCallThrough();var e=o.applyFilter("filter","compareTypeName","catpants");expect(e).toBeTruthy();var t=o.insertFilter.mostRecentCall.args[0];expect(t.values().length).toEqual(1),expect(t.values()[0]).toEqual("catpants")}),it("will convert inserted filter compare type if given string",function(){spyOn(o,"compareTypeFromName").andReturn("compareType"),spyOn(o,"insertFilter").andReturn(!0);var e=o.applyFilter("filter","compareTypeName","value");expect(e).toBeTruthy(),expect(o.compareTypeFromName).wasCalled(),o.compareTypeFromName.reset(),e=o.applyFilter("filter",{},"value"),expect(e).toBeTruthy(),expect(o.compareTypeFromName).wasNotCalled()}),it("will fail if compare type is not found",function(){spyOn(o,"compareTypeFromName").andReturn(null),spyOn(o,"insertFilter").andReturn(!0);var e=o.applyFilter("filter","compareTypeName","value");expect(e).toBeFalsy(),expect(o.compareTypeFromName).wasCalled()})})})